;;	Csound orchestra chips.orc

;; 	(c) Risto Holopainen 2014
	
;;	Copying and distribution of this file, with or without modification,
;;	are permitted in any medium without royalty provided the copyright
;;	notice and this notice are preserved.  This file is offered as-is,
;;	without any warranty.


sr		=	48000
kr		=	12000
ksmps	=	4
nchnls	=	2


0dbfs = 1.0




;;---sqimp.ORC ---


instr 1
;;sqimp i1

; square wave -> sinus
 asq		init		0
 ipan		=		p6	; 0 < p < 1 --> v<->h
 iL			=		sqrt(ipan)
 iR			=		sqrt(1-ipan)

 asin		oscili	1, p5, 1
 kgain		expon	12, p3, 0.5
 asq		=		tanh(kgain*asin + .95*asq) ; .8
 klin		linen	1, 0.001, p3, 0.02
 kxp		expon	1, p3, 0.001
 kamp		=		p4*klin*kxp

; med brusattack
 anos		rand	kxp*kxp
 amo		oscili	anos, 600+kxp*2400, 1

 aL			=		iL*kamp*(.7*asq + .3*amo)
 aR			=		iR*kamp*(.7*asq + .3*amo)
 
			outs	aL, aR
endin






instr 2 ORGEL_FAGOTT
;; csound/oddjob i4

 aos	init	0
 ac		init	0
 afbk	init	0
 
 kop	expon	1.0, sqrt(p3), 0.1
 kup	line	0.1, p3, 1
 
 kvib	oscil	kop * kup, 6*(0.9-kop) + p4, 1, .45
 kfrq	=		p5 * (1 + .03*kvib)
 
 kvarp	=		(0.076 + 0.03*kup)*p4
 amod	oscil	1, kfrq*(2.0 + ac + kvarp*afbk), 1
 amod	butbp	amod, p5, .6*p5

 ac		oscil	1, kfrq * (1 + 1.2*amod), 1
 aos1	oscil	1, kfrq * (1/2 + 2.0*ac), 1

 aos1	butlp	aos1, 20*sqrt(p5) + 800 
 aosL	dcblock	(.2*aos + .8*aos1)^2 - (amod + ac)*.125
 aosR	dcblock	(.2*aos - .8*aos1)^2 - (amod - ac)*.125
 idl	=		(p5 > 1) ? p5 : 1;
 afbk	delay	aos1 + .25*(aosL+aosR), 3.0/idl
 
 kl		linen	p4, 0.01, p3, 0.03

		outs	kl*aosL, kl*aosR

endin





instr 5
; sqimp i3

 ip1	=		0.99*p5
 ip2	=		p5
 ip3	=		1.01*p5
 ip4	=		0.51*p5 - 1.5
 ip5	=		2.01*p5
 
 isqp	=		sqrt(p5)
 
 kam1	oscili	1, 0.1*p4 + 1/isqp, 1, 0
 kam2	oscili	1, 0.1*p4 + 1/isqp, 1, .25 
 kam3	oscili	1, 0.2*p4 + 2/isqp, 1, .5

 aos1	oscil	.7 + .3*kam1, ip1, 1
 aos2	oscil	.9 + .1*kam2, ip2, 1
 aos3	oscil	.7 - .3*kam1, ip3, 1
 aos4	oscil	.5 + .5*kam3, ip4, 1
 aos5	oscil	.6 - .4*kam3, ip5, 1

 idd	=			p3/15.
 kenv	linen		1, 0.45+idd, p3, 0.36 + idd/2
 ahp	dcblock		aos1^2 - aos3^2
 
 klp	=			300 + 300*(1+kam1) + 600*(1+kam3)

 amix	butterlp	(kenv*aos2)^3  + .5*aos4 + .75*aos5, 2100
 aws	tone		taninv(.5*ahp + amix), klp
 aotL	butterhp	.3*(aws + amix + .5*aos1), 80
 aotR	butterhp	.3*(aws + amix + .5*aos3), 80
 
		outs		.95*p4*kenv*aotL, .97*p4*kenv*aotR

endin








